#affiche les niveaux de covariance et de correlations
# distance,lqi
# distance,rssi

len = length(inp1$src)#10000

lqi.values <- numeric()
rssi.values <- numeric()
distance.values <- numeric()
lqis <- numeric()
rssis <- numeric()
N <- 0
for (i in 2:20) {
  for (j in 2:20) {
      x <- 0
      if (i != j) {
        for (k in 1:len) {
          if ((inp1$src[k] == i && inp1$pongsrc[k] == j)) {
            lqis[x] <- inp1$lqi[k]
            rssis[x] <- inp1$rssi[k]
            x<-x+1
         }
        }
      lqi.values[N] <- mean(lqis)
      rssi.values[N] <- mean(rssis)
      distance.values[N] <- distance(i,j)
      N <- N+1
      }
  }
}
cov.lqi <- cov(distance.values,lqi.values)
cov.rssi <- cov(distance.values,rssi.values)

cor.lqi <- cov.lqi / sqrt(var(distance.values)*var(lqi.values))
cor.rssi <- cov.rssi / sqrt(var(distance.values)*var(rssi.values))

print(paste("Covariance distance - lqi",cov.lqi))
print(paste("Correlation distance - lqi",cor.lqi))

print(paste("Covariance distance - rssi",cov.rssi))
print(paste("Correlation distance - rssi",cor.rssi))