#distancesBib.r

#	NETWORK TOPOLOGY

# 	5	9	13	17
#
# 	4	8	12	16	20	<
#						| vdist
# 	3	7	11	15	19	<
#
# 	2	6	10	14	18
#	<-hdist->

#right now we'll say hdist = 1
#and vdist = 1
#But this could measured in the biblio

#coord<-function(n) {

#xi<-(n-2)%%4
#yi<-(n-2)%/%4

#c(xi,yi)
#}

#dist<-function(ni,nj) {sqrt(sum(coord(ni)-coord(nj)^2))}


#	col
#	0  1 2  3  4

#lig 3	3 7 11 15
#    2	2 6 10 14 18
#    1	1 5 9  13 17
#    0	0 4 8  12 16


#ddist <- sqrt((hdist ^ 2)+(vdist ^ 2))


#returns the distance between 2 nodes (oracle)
distance <- function(AnodeId,BnodeId) {
hdist <- 1.5
vdist <- 1


	if (AnodeId == BnodeId) {
		return(0)
	}

	#to begin at 0
	A <- AnodeId - 2
	B <- BnodeId - 2

	dist <- 0


	if (A > B) {
		tmp = B;
		B = A;
		A = tmp;
	} #now A is everytime the node with smaller nodeId

	Acol <- A %/% 4
	Alig <- A %% 4
	Bcol <- B %/% 4
	Blig <- B %% 4

	if (Acol == Bcol) {
		return ((Blig - Alig) * vdist)
	}

	if (Alig == Blig) {
		return ((Bcol - Acol) * hdist)
	}


	#if we arrive here both nodes are neithwarningser same lig neither same col

	if (Alig < Blig) {
		return (sqrt((((Bcol - Acol)*hdist)^2) + (((Blig - Alig)*vdist)^2)) )
	}
	else {
		return (sqrt((((Bcol - Acol)*hdist)^2) + (((Alig - Blig)*vdist)^2)) )
	}
}


  real.x <- numeric()
  real.y <- numeric()
  real.x[1] <- 0
  real.y[1] <- 0
  real.x[2] <- 0
  real.y[2] <- 1
  real.x[3] <- 0
  real.y[3] <- 2
  real.x[4] <- 0
  real.y[4] <- 3

  real.x[5] <- 1.5
  real.y[5] <- 0
  real.x[6] <- 1.5
  real.y[6] <- 1
  real.x[7] <- 1.5
  real.y[7] <- 2
  real.x[8] <- 1.5
  real.y[8] <- 3

  real.x[9] <- 3
  real.y[9] <- 0
  real.x[10] <- 3
  real.y[10] <- 1
  real.x[11] <- 3
  real.y[11] <- 2
  real.x[12] <- 3
  real.y[12] <- 3

  real.x[13] <- 4.5
  real.y[13] <- 0
  real.x[14] <- 4.5
  real.y[14] <- 1
  real.x[15] <- 4.5
  real.y[15] <- 2
  real.x[16] <- 4.5
  real.y[16] <- 3

  real.x[17] <- 6
  real.y[17] <- 0
  real.x[18] <- 6
  real.y[18] <- 1
  real.x[19] <- 6
  real.y[19] <- 2

  real.x <- real.x - mean(real.x)
  real.y <- real.y - mean(real.y)