#locaMDSmultiRFRSSI.R
#inp1 <- scan("neighbors.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")

#mettre dans des vecteurs le donnes par rflevel power

values <- list()
reg.Errors <- numeric()
reg.Intercepts <- numeric()
reg.Lqis <- numeric()

mds.mse <- numeric()
real.dist<-array(NA,c(19,19))
diag(real.dist) <- 0.0

good <- list()

#We put the values in a list indexed by Radio Power
for (x in 1:31) {
  values[[x]] <- c(-10,-10)
}

for (i in 1:length(inp1$idx)) {
  aa <- inp1$seqno[i] %/% 10
  if (aa > 30) {  aa <- aa %% 31 }
  if ( values[[(aa + 1)]][1] == -10 ) {
    values[[(aa + 1)]] <- c(inp1$seqno[i],inp1$src[i],inp1$pongsrc[i],inp1$rssi[i])
  } else {
    values[[(aa + 1)]] <- rbind(values[[(aa + 1)]],c(inp1$seqno[i],inp1$src[i],inp1$pongsrc[i],inp1$rssi[i]))
  }

}
#We put the real distances in real.dist
for (i in 2:19) {
  for (j in (i+1):20) {
        real.dist[i-1,j-1] <- distance(i,j)
        real.dist[j-1,i-1] <- real.dist[i-1,j-1]
  }
}
#we put the positions calculated from the real distance by mds in real.x real.y
#browser()
#mds <- cmdscale(real.dist,add=TRUE,eig=TRUE,k=18)

#real.x <- mds$points[,1]
#real.y <- -mds$points[,2]

# pour tous les radios power : calculer la droite de regression
for (radf in 1:31) {


  distX <- numeric()
  lqiX <- numeric()

  len <- length(values[[radf]][,1])
  x<- 0

  mean.lqi<-array(NA,c(19,19))
  mean.dist<-array(NA,c(19,19))
  for (i in 2:20) {
   for (j in 2:20) {
    tmp<-mean(values[[radf]][(values[[radf]][,2]==i)&(values[[radf]][,3]==j) | (values[[radf]][,2]==j)&(values[[radf]][,3]==i) ,4])
    if (!is.nan(tmp)) mean.lqi[i-1,j-1]<-tmp
    mean.dist[i-1,j-1]<-distance(i,j)
   }
  }

  distX<-as.numeric(mean.dist)
  lqiX<-as.numeric(mean.lqi)
  lin <- lm(distX ~ lqiX,na.action=na.exclude)

  #x11()
  #plot(lqiX,distX,col = hsv(radf/31,.5,.5),pch=20,main=paste("lqi/dist rfpower= ",radf))
  #abline( coef = lin$coefficients , col = hsv(radf/31,.5,.5))
  reg.Intercepts[radf] <- lin$coefficients[1]
  reg.Lqis[radf] <- lin$coefficients[2]
  reg.Errors[radf] <- sum(lin$residuals^2)/length(lin$residuals)

  #browser()
}
# pour tous les radios levels
for (radf in 2:31) {
    act.lqi<-array(NA,c(19,19))
    act.dist<-array(NA,c(19,19))
    comp.dist<-array(NA,c(19,19))

    diag(act.dist) <- 0.0

    #remplir la matrice de distance avec les valeurs que l'on a
    for (i in 2:20) {
      for (j in 2:20) {
          if (i !=j ) {

            tmp<-mean(values[[radf]][(values[[radf]][,2]==i)&(values[[radf]][,3]==j) | (values[[radf]][,2]==j)&(values[[radf]][,3]==i),4])
            if (!is.nan(tmp)) {
              #act.dist[i-1,j-1]<- reg.Intercepts[radf] + reg.Lqis[radf] * tmp
              act.dist[i-1,j-1]<- tmp
              act.dist[j-1,i-1]<- act.dist[i-1,j-1]
            }
          }
      }
    }
    #remplir les donnes manquantes avec le shortest path length
    comp.dist <- allShortestPaths(act.dist)$length


    #appliquer le mds
    mds <- cmdscale(comp.dist,add=TRUE,eig=TRUE,k=18)

    x <- mds$points[,1]
    y <- -mds$points[,2]

    #center on origin
    #x <- x - mean(x)
    #y <- y - mean(y)

    #rotation et scaling des positions rsultantes pour s'adapter au "bon plan"

    xy <- cbind(x,y)
    xoyo <-cbind(real.x,real.y)

    #browser()

    good[[radf]] <- procrustes(xoyo, xy, scale=T)

    #calcul de l'erreur par rapport au bon plan
    mds.mse[radf] <-  sqrt(good[[radf]]$ss/19)

    if (radf == 2) {
      plot(good[[radf]]$Yrot,col = hsv(radf/31,.7,.5),pch=20,xlim=c(-3,3),ylim=c(-3,3))
    } else  {
      points(good[[radf]]$Yrot,col = hsv(radf/31,.7,.5),pch=20)
    }
    text (good[[radf]]$Yrot,labels=2:20,col = hsv(radf/31,.7,.5))


}
      points(real.x,real.y,pch=21)
      text(real.x,real.y,labels=2:20)


vmin <- mds.mse[2]
imin <- 2
vmax <- mds.mse[2]
imax <- 2
for (i in 3:19) {
   if ( mds.mse[i] < vmin ) {
      vmin <- mds.mse[i]
      imin <- i
   }
   if ( mds.mse[i] > vmax ) {
      vmax <- mds.mse[i]
      imax <- i
   }

}
x11()
plot(good[[imin]])
x11()
barplot(mds.mse)
x11()
plot(good[[imax]])

browser()
errors<-data.frame(residuals(good[[2]]))
for (i in 3:31) {
 errors<-data.frame(errors,residuals(good[[i]]))
}
colnames(errors)<-2:31
par(las=2)
boxplot(errors)
#TO TRY !!
# make a kind of mean between all the positions returned by the 31 MDS/PROCRUSTES for each node
# calculate if better error !