# plotDistLqi.R
# plot distance vs lqi for all nodes

	lqiX <- numeric()
	distX <- numeric()


	x <- 0

	len <- length(inp1$lqi)

	for (i in 1:len) {
		if (inp1$src[i] > 1 && inp1$pongsrc[i] > 1) {
		  d <-  (inp1$seqno[i] %% 10)
			if (d == 0) {
        lqiX[x] <- inp1$lqi[i]
  			distX[x] <- distance(inp1$src[i],inp1$pongsrc[i])
  			x<-x+1
       }
		}

	}

  #browser()

#  i <- (distX < 5 && distX > 4)
#  distX <-distX[i]
#  lqiX <- lqiX[i]
	#filename <- "distance-lqi.ps"
	#postscript(filename, family = "NimbusSan")

	x11()

  lin <- lm(distX ~ lqiX)

	maintitle <- paste("Distance / LQI")
  plot(lqiX,distX,main=maintitle,ylab="Distance Between nodes",xlab="LQI value",pch=3, col = "dark red")

  mytext1 <- paste("LQI mean :",mean(lqiX),"LQI var :",var(lqiX),"#mesures :",length(distX))
  mytext2 <- paste("#nodes : 19","regline intercept :",lin$coefficients[1],"regline lqiX :",lin$coefficients[2])

  mtext(mytext1, side = 1,line=2)
  mtext(mytext2, side = 1,line=4)


	abline( coef = lin$coefficients )

	#print (lin$coefficients)
  sqrt(var(lin$residuals))


	#dev.off()

