# plotDistRssi.R
# plot distance vs rssi for all nodes

distX <- numeric()
rssiX <- numeric()

len <- length(inp1$time)
x<- 0

for (i in 1:len) {
	if (inp1$src[i] > 1 && inp1$pongsrc[i] > 1) {
	  d <-  (inp1$seqno[i] %% 10)
		if (d == 0) {
    		rssiX[x] <- inp1$rssi[i]
    		distX[x] <- distance(inp1$src[i],inp1$pongsrc[i])
    		x<-x+1
  		}
	}

}

x11()

lin <- lm(distX ~ rssiX)

maintitle <- paste("Distance / RSSI")
plot(rssiX,distX,main=maintitle,ylab="Distance Between nodes",xlab="RSSI value",pch=3, col = "dark red")

mytext1 <- paste("RSSI mean :",mean(rssiX),"RSSI var :",var(rssiX),"#mesures :",length(distX))
mytext2 <- paste("#nodes : 19","regline intercept :",lin$coefficients[1],"regline lqiX :",lin$coefficients[2])

mtext(mytext1, side = 1,line=2)
mtext(mytext2, side = 1,line=4)


abline( coef = lin$coefficients )




