plotLQIps <- function(nodeid=2) {
	oldwd = getwd()
	setwd("C:\\Documents and Settings\\dwarfy\\My Documents\\MLG\\memoiremlg\\LOCALISATION\\EXPEBIBLIO")

	inp1 <- scan("N1.txt", list(0,0,0,0,0,0,0),dec = ",")
	lqi1 <- inp1[[6]]
	fromid1 <- inp1[[4]]
	toid1 <- inp1[[5]]
	time1 <- inp1[[1]]

	inp2 <- scan("N2.txt", list(0,0,0,0,0,0,0),dec = ",")
	lqi2 <- inp2[[6]]
	fromid2 <- inp2[[4]]
	toid2 <- inp2[[5]]
	time2 <- inp2[[1]]
	
	setwd(oldwd)

	lqi = c(lqi1,lqi2)
	fromid = c(fromid1,fromid2)
	toid = c(toid1,toid2)
	times = c(time1,time2)

	x <- 0
	len <- length(times)
	lqiX <- numeric()
	timesX <- numeric()

	startime <- 0.0

	times <- times / (3600 * 1024)

	for (j in 1:20) {
		x <- 0
		for (i in 1:len) {
			if (i != j) {
				if (fromid[i] == nodeid && toid[i] == j ) {
					if (x == 0) {
						startime = times[i]
					}
					lqiX[x] <- lqi[i]
					timesX[x] <- times[i] - startime
					x<-x+1
				}
			}
		}
		
		filename <- paste("lqinode",nodeid,"to",j,".ps",sep="") 
		postscript(filename, family = "NimbusSan")

		maintitle <- paste("LQI node",nodeid,"to",j)
		subtitle <- paste("LQI mean :",mean(lqiX),"| LQI var :",var(lqiX))
		plot(timesX,lqiX,main=maintitle,sub=subtitle,xlab="Time from start of experience (hours)",ylab="LQI value",pch=20)
		
		dev.off()

	}

	
}

plotLQIps(2)
plotLQIps(18)