/*
 * RcvPanel.java
 *
 * Created on 19 mars 2007, 11:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author dwarfy
 */

package net.tinyos.mapviewer;


import javax.swing.*;

import java.awt.*;              //for layout managers and more
import java.awt.geom.*;

public class RcvPanel extends JPanel {
    long[] rcvPackets = new long [Config.NUM_ANCHORS];
    /** Creates a new instance of RcvPanel */
    public RcvPanel() {
        for (int x=0;x<Config.NUM_ANCHORS;x++) {
            rcvPackets[x]=0;
        }
        Font font = new Font("Serif", Font.PLAIN, 10);
        setFont(font);
    }
    
     public void paintComponent(Graphics g) {
           int iix,iiy;
            iix=5;
            super.paintComponent(g);
            Graphics2D g2d = (Graphics2D)g;
            g2d.setPaint(Color.black);
            for (int x=0;x<Config.NUM_ANCHORS;x++) {
                iiy=10+x*10;
                g2d.drawString("Msgs from node :".concat(String.valueOf(x)).concat(" = ").concat(String.valueOf(rcvPackets[x])), iix, iiy);    
            }
            
           
     }
     
     public void ping(short nodeId) {
         rcvPackets[Config.getAnchorIdx(nodeId)]++;
         
     }
    
}
