/*
 * Estimator.java
 *
 * Created on 12 mars 2007, 0:11
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author dwarfy
 */

package net.tinyos.mapviewer;

import java.util.LinkedList;
import java.util.ListIterator;

import net.tinyos.tools.NodeInfoMsg;

public class Estimator {
    Calibrator C;
    SerialReceiver R;
    MapContainerPanel M;
    
    Estimator() {
        
    }
  
    //we are waiting a functionnal initialised SerialReceiver as the parameter
    void setSerial(SerialReceiver Ser) {
        R = Ser;
    }
    
    //we are waiting a functionnal initialised Calibrator as the parameter
    void setCalib(Calibrator Cal) {
        C = Cal;
    }
    
    void setMap(MapContainerPanel p) {
       M=p; 
    }
       
    public float[] getDistances(int fromnodeidx) {
         float lqiMean=0;
        float[] distances =new float[Config.NUM_ANCHORS];
        
        for (int x=0;x<Config.NUM_ANCHORS;x++) {
            ListIterator<NodeInfoMsg> it = R.getNodeInfoList().listIterator();   
            while (it.hasNext()) {
                   NodeInfoMsg m = (NodeInfoMsg)it.next();
                   if (m.get_idN() == 20){
                       if (m.get_idA() == Config.ANCHORS_IDS[x]) {
                            System.out.println("lqiMean = ".concat(Float.toString(m.get_lqi())));
                            distances[x] = C.getDistance( m.get_lqi());
                            break;
                       }
                   }
            }
        }
        return distances;
    }
    //return a table with distance between node id & all anchors NOW
 /*  public float[] getDistances(int fromnodeidx) {
        float[] distances =new float[Config.NUM_ANCHORS];
        short[][] lqis = new short[Config.NUM_ANCHORS][Config.NUM_LQIS_ESTIM];
        int[] lqiscnts = new int[Config.NUM_ANCHORS];
        
        for (int x=0;x<Config.NUM_ANCHORS;x++) {
            lqiscnts[x]=0;
        }
        
        //to have a list iterator starting at end
        ListIterator<NodeInfoMsg> it = R.getNodeInfoList().listIterator();
        boolean full=false;

        while (it.hasNext() && !full) {
            NodeInfoMsg m = (NodeInfoMsg)it.next();
            if (m.get_idN() == Config.NODES_IDS[fromnodeidx]){
               /* if (lqiscnts[Config.getAnchorIdx(m.get_idA())] < Config.NUM_LQIS_ESTIM) {
                    lqis[Config.getAnchorIdx(m.get_idA())][lqiscnts[Config.getAnchorIdx(m.get_idA())]] = m.get_lqi();
                    lqiscnts[Config.getAnchorIdx(m.get_idA())]++;
                }
                full = isFull(lqiscnts) 
                lqiMean = 
            }
        }
        
        if (!full) {
            //error sleep a bit and retry
            System.out.println("not full");
        }
        
        for (int x=0;x<Config.NUM_ANCHORS;x++) {
            float lqiMean=0;
            for (int y=0;y<Config.NUM_LQIS_ESTIM;y++) {
                lqiMean+=(float) lqis[x][y];
            }
            lqiMean/=Config.NUM_LQIS_ESTIM;
            
            System.out.println("lqiMean = ".concat(Float.toString(lqiMean)));
            
            
            
            distances[x] = C.getDistance(lqiMean);
            
            
        }
        return distances;
        
    }*/
    
    private boolean isFull(int[] cnts) {
        for (int x=0;x<Config.NUM_ANCHORS;x++) {
            if (cnts[x] < Config.NUM_LQIS_ESTIM) {
                return false;
            }
        }
        return true;
    }
    
}
