/*
 * RefreshThread.java
 *
 * Created on 9 mars 2007, 13:36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author dwarfy
 */
package net.tinyos.mapviewer;


import javax.swing.*;
import java.io.IOException;

import java.awt.*; 


public class RefreshThread extends Thread{
    long minPrime;
    MapContainerPanel obj;
    public RefreshThread(int mp) {
        minPrime=mp;
    }



    public void setRefreshObj(MapContainerPanel o){
        obj = o;
    }
    
        public void run() {

        //1 create a new serial receiver
        obj.log("Starting SerialReceiver");
        SerialReceiver Ser = new SerialReceiver();
        Ser.setMap(obj);
        Ser.setRcv(obj.rcvPane);


        obj.log("Waiting for some messages from nodes");
        
        while(Ser.getNodeInfoList().size() == 0 ) {
                try {
                    Thread.sleep(2000);
                    obj.log("RefreshThread: waiting for nodeInfoMessages");
                } catch (Exception e) {
                    System.out.println("RefreshThread: can't sleep");
                }
         }


        //4 Localisator
         obj.log("Starting Localisator");
         Localisator Loc = new Localisator();
         Loc.setSerial(Ser);

        //5 Start the Stabilisator and let him make his job
         obj.log("Starting Stabilisator");
         Stabilisator Stab = new Stabilisator();
         Stab.setLocalisator(Loc);
         obj.setStab(Stab);
         
         while (true) {
            try {
               Thread.sleep(Config.REFRESH_TIME);
            } catch (Exception e) {
                System.out.println("RefreshThread: can't sleep");
            }
            
            if(obj.historyCheck.isSelected()) {
                Stab.updatePaths();
            }
            
            obj.refresh();
         }
         
    }



}


