//Localiser.h
#ifndef H_Localiser_h
#define H_Localiser_h

enum {
	AM_NODEBEEPMSG = 33,
	AM_NODEINFOMSG = 34,
	AM_CALIBRATIONMSG = 35,
  	AM_RADIOPOWERMSG = 38,



	//node specific
	NODE_MESSAGE_TIME = 1024, //millisec
	DEFAULT_NODE_RADIO = 1,







};

//message sent by (moving) nodes to be localised
typedef struct NodeBeepMsg {
	uint8_t id;
	uint32_t timestamp;
} NodeBeepMsg;


//message sent by anchors nodes about when he receive a moving node beep
typedef struct NodeInfoMsg {
	uint32_t timestamp;
	uint8_t idN;
	uint8_t idA;
	uint8_t rssi;
	uint8_t lqi;
} NodeInfoMsg;

#endif
